'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.default = packAgents;

var _fs = require('mz/fs');

var _fs2 = _interopRequireDefault(_fs);

var _writeFilePromise = require('write-file-promise');

var _writeFilePromise2 = _interopRequireDefault(_writeFilePromise);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _invertObject = require('../lib/invertObject');

var _invertObject2 = _interopRequireDefault(_invertObject);

var _stringifyObject = require('../lib/stringifyObject');

var _stringifyObject2 = _interopRequireDefault(_stringifyObject);

var _base = require('../lib/base62');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var browsersData = require('../../data/browsers');
var browsers = (0, _invertObject2.default)(browsersData);

function relevantKeys(versions, agents, fullAgents) {
    var versionsInverted = (0, _invertObject2.default)(versions);
    return Object.keys(agents).reduce(function (map, key) {
        var agent = agents[key];
        map[browsers[key]] = {
            A: Object.keys(agent.usage_global).reduce(function (list, k) {
                var val = agent.usage_global[k];
                list[versionsInverted[k]] = val;
                return list;
            }, {}),
            B: agent.prefix,
            C: agent.versions.reduce(function (list, version) {
                if (version === null) {
                    list.push('');
                } else {
                    list.push(versionsInverted[version]);
                }
                return list;
            }, []),
            E: agent.browser,
            F: fullAgents[key].version_list.reduce(function (map, item) {
                map[versionsInverted[item.version]] = item.release_date;
                return map;
            }, {})
        };
        if (agent.prefix_exceptions) {
            map[browsers[key]].D = agent.prefix_exceptions;
            map[browsers[key]].D = Object.keys(agent.prefix_exceptions).reduce(function (list, k) {
                var val = agent.prefix_exceptions[k];
                list[versionsInverted[k]] = val;
                return list;
            }, {});
        }
        return map;
    }, {});
}

function packBrowserVersions(agents) {
    var browserVersions = Object.keys(agents).reduce(function (map, key) {
        var versions = Object.keys(agents[key].usage_global);
        versions.forEach(function (version) {
            var exists = map.find(function (v) {
                return v.version === version;
            });
            if (exists) {
                exists.count++;
            } else {
                map.push({ version: version, count: 1 });
            }
        });
        return map;
    }, []).sort(function (a, b) {
        return b.count - a.count;
    }).reduce(function (map, version, index) {
        map[(0, _base.encode)(index)] = version.version;
        return map;
    }, {});

    return (0, _writeFilePromise2.default)(_path2.default.join(__dirname, '../../data/browserVersions.js'), (0, _stringifyObject2.default)(browserVersions)).then(function () {
        return [agents, browserVersions];
    });
}

function packAgents() {
    // We're not requiring the JSON because it nukes the null values
    return _fs2.default.readFile(require.resolve('caniuse-db/data.json'), 'utf8').then(function (data) {
        return JSON.parse(data).agents;
    }).then(packBrowserVersions).then(function (data) {
        return _fs2.default.readFile(require.resolve('caniuse-db/fulldata-json/data-2.0.json'), 'utf8').then(function (fullData) {
            return [data, JSON.parse(fullData).agents];
        });
    }).then(function (_ref) {
        var _ref2 = _slicedToArray(_ref, 2),
            _ref2$ = _slicedToArray(_ref2[0], 2),
            agents = _ref2$[0],
            versions = _ref2$[1],
            fullAgents = _ref2[1];

        return (0, _writeFilePromise2.default)(_path2.default.join(__dirname, '../../data/agents.js'), (0, _stringifyObject2.default)(relevantKeys(versions, agents, fullAgents)));
    });
}