'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = packBrowsers;

var _fs = require('mz/fs');

var _fs2 = _interopRequireDefault(_fs);

var _writeFilePromise = require('write-file-promise');

var _writeFilePromise2 = _interopRequireDefault(_writeFilePromise);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _stringifyObject = require('../lib/stringifyObject');

var _stringifyObject2 = _interopRequireDefault(_stringifyObject);

var _base = require('../lib/base62');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getBrowsers(data) {
    var feature = Object.keys(data)[0];
    var browsers = Object.keys(data[feature].stats);

    return browsers.reduce(function (packed, browser, index) {
        packed[(0, _base.encode)(index)] = browser;
        return packed;
    }, {});
} /* Create a mapping from browser version strings to shorter identifiers. */

function packBrowsers() {
    return (0, _writeFilePromise2.default)(_path2.default.join(__dirname, '../../data/browsers.js'), (0, _stringifyObject2.default)(getBrowsers(require('caniuse-db/data.json').data)));
}