'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = packRegion;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('mz/fs');

var _fs2 = _interopRequireDefault(_fs);

var _writeFilePromise = require('write-file-promise');

var _writeFilePromise2 = _interopRequireDefault(_writeFilePromise);

var _babelTypes = require('babel-types');

var t = _interopRequireWildcard(_babelTypes);

var _base = require('../lib/base62');

var _getContents = require('../lib/getContents');

var _getContents2 = _interopRequireDefault(_getContents);

var _invertObject = require('../lib/invertObject');

var _invertObject2 = _interopRequireDefault(_invertObject);

var _stringifyObject = require('../lib/stringifyObject');

var _stringifyObject2 = _interopRequireDefault(_stringifyObject);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var browsers = require('../../data/browsers');
var versions = require('../../data/browserVersions');

var browsersInverted = (0, _invertObject2.default)(browsers);
var versionsInverted = (0, _invertObject2.default)(versions);

var base = _path2.default.join(_path2.default.dirname(require.resolve('caniuse-db/data.json')), 'region-usage-json');

var getContents = (0, _getContents2.default)(base);

function packRegion() {
    return _fs2.default.readdir(base).then(getContents).then(function (regions) {
        return Promise.all(regions.map(function (region) {
            var data = region.contents.data;

            var packed = Object.keys(data).reduce(function (list, key) {
                var stats = data[key];
                list[browsersInverted[key]] = Object.keys(stats).reduce(function (l, k) {
                    var stat = stats[k];
                    if (stat === null) {
                        if (l._) {
                            l._ += ' ' + k;
                        } else {
                            l._ = '' + k;
                        }
                        return l;
                    }
                    l[k] = stat;
                    return l;
                }, {});
                return list;
            }, {});

            return (0, _writeFilePromise2.default)(_path2.default.join(__dirname, '../../data/regions/' + region.name + '.js'), (0, _stringifyObject2.default)(packed));
        }));
    });
}